/*
 * test
 *
 * Copyright (c) 2013 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "test.h"
#include "config.h"

static void test_main(int argc, char **argv)
{
	_I("auto test all");
	test_init((void *)NULL);
	test_exit((void *)NULL);
}

static void unit_test(int argc, char **argv)
{
	const struct test_ops *ops;

	ops = find_test(argv[2]);
	if (!ops) {
		_E("there is no test ops : %s", argv[2]);
		return;
	}
	ops->unit(argc, argv);
}

void show_usage()
{
	printf("Usage: deviced-auto-test [PROFILE] [MODULE] [UNIT-METHOD] [OPTS]\n\n");
	printf("Mandatory arguments\n");
	printf("[PROFILE] :\n");
	printf("\tmobile\n\twearable\n\ttv\n\tivi\n\tcommon\n\n");
	printf("Optional arguments\nIf you don't give any optional arguments, all supported modules will be tested.\n");
	printf("All module list is as below.\nAs per profile, supported modules are different.\n");
	printf("[MODULE]:\n");
	printf("\tbattery\n");
	printf("[UNIT-METHOD], [OPTS]:\n");
	printf("\tThis is refered to module information.\n");
	printf("\tThis can not be used without [MODULE] argument.\n\n");
}

int main(int argc, char **argv)
{
	if (argc < 2) {
		show_usage();
		return 0;
	}

	test_config_load(argv[1]);
	config_test();

	if (argc >= 3)
		unit_test(argc, argv);
	else
		test_main(argc, argv);

	test_config_unload();

	return 0;
}

